#include <extdll.h>			// always
#include <meta_api.h>		// of course
#include <dllapi.h>
#include "sdk_util.h"		// UTIL_LogPrintf, etc
#include <h_export.h>
#include "plugin.h"
#include "cbase.h"
#include <usercmd.h>
#include <pm_defs.h>

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;

cvar_t nsa_jetpack_chargerate			   = {"nsa_jetpack_chargerate",	      "2.00",				   FCVAR_ARCHIVE};
cvar_t nsa_jetpack_fuelrate				   = {"nsa_jetpack_fuelrate",	      "4.00",				   FCVAR_ARCHIVE};


void PlayerPreThink(edict_t *pEntity)
{
	if(pEntity->v.iuser4 & (1<<9) && pEntity->v.team == 1)//Do they have a jetpack? and are they on team 1 (Marines)
	{		
		if(!(pEntity->v.flags & FL_ONGROUND))//Are they flying around?
		{
			pEntity->v.fuser3 = pEntity->v.fuser4;
			
			if(pEntity->v.button & IN_JUMP)//They are holding jump key, so eat up fuel.
				if(pEntity->v.fuser3 > CVAR_GET_FLOAT("nsa_jetpack_fuelrate"))
					pEntity->v.fuser3 -= CVAR_GET_FLOAT("nsa_jetpack_fuelrate");

				if(pEntity->v.fuser3 < 0)//Sanity check.
					pEntity->v.fuser3 = 0;
		}
		else if(pEntity->v.flags & FL_ONGROUND)
		{
			pEntity->v.fuser3 = pEntity->v.fuser4;
			
			if(pEntity->v.fuser3 < 1000)
				pEntity->v.fuser3 += CVAR_GET_FLOAT("nsa_jetpack_chargerate");
			
			if(pEntity->v.fuser3 > 1000)//Sanity check.
				pEntity->v.fuser3 = 1000;
		}
		pEntity->v.fuser4 = pEntity->v.fuser3;
	}
	RETURN_META(MRES_IGNORED);
}

// Must provide at least one of these..
static META_FUNCTIONS gMetaFunctionTable = {
		NULL,			// pfnGetEntityAPI				HL SDK; called before game DLL
		NULL,			// pfnGetEntityAPI_Post			META; called after game DLL
		GetEntityAPI2,	// pfnGetEntityAPI2				HL SDK2; called before game DLL
		NULL,			// pfnGetEntityAPI2_Post		META; called after game DLL
		NULL,			// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
		NULL,			// pfnGetNewDLLFunctions_Post	META; called after game DLL
		NULL,			// pfnGetEngineFunctions		META; called before HL engine
		NULL,			// pfnGetEngineFunctions_Post	META; called after HL engine
};

// Description of plugin
plugin_info_t Plugin_info = {
	META_INTERFACE_VERSION,	// ifvers
		"JetpackM",	// name
		"1.0",		// version
		"6/16/2003",	// date
		"voogru <voogru@voogru.com>",	// author
		"http://www.voogru.com",	// url
		"JETPACKM",	// logtag
		PT_CHANGELEVEL,// (when) loadable
		PT_CHANGELEVEL,// (when) unloadable
};

// Global vars from metamod:
meta_globals_t *gpMetaGlobals;		// metamod globals
gamedll_funcs_t *gpGamedllFuncs;	// gameDLL function tables
mutil_funcs_t *gpMetaUtilFuncs;		// metamod utility functions

C_DLLEXPORT int Meta_Query(char *ifvers, plugin_info_t **pPlugInfo,	mutil_funcs_t *pMetaUtilFuncs) {
	*pPlugInfo=&Plugin_info;
	gpMetaUtilFuncs=pMetaUtilFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs) {
	gpMetaGlobals=pMGlobals;
	memcpy(pFunctionTable, &gMetaFunctionTable, sizeof(META_FUNCTIONS));
	gpGamedllFuncs=pGamedllFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME now, PL_UNLOAD_REASON reason) 
{
	return(TRUE);
}

void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals ) {
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;	
	
	CVAR_REGISTER(&nsa_jetpack_chargerate);
	CVAR_REGISTER(&nsa_jetpack_fuelrate);

}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) 
{
	gFunctionTable.pfnPlayerPreThink = PlayerPreThink;
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

